function [] = runPreviewPOP(musArr44100, movPop, corArrDB, clickDBtimeMs, startClickNr, endClickNr)
    
    % Plotter i fig 2
    
    cntArr525pop = makeCntArr525pop(movPop, corArrDB);
    
    fig2;
    xDiv = 1.5;
    yDiv = 1.5;
    noX = 4;
    noY = 4;
    
    setUp2dView('backCol',[0.2 0.2 0.2]);
    for y = 0 : noY
        line([0 (noX)*xDiv], [y*yDiv y*yDiv], 'color', [1 0.8 0.8]);
    end
    for x = 0 : noX
        line([x*xDiv x*xDiv], [0 (noY)*yDiv], 'color', [1 0.8 0.8]);
    end
    
    fs = 44100;
    startSampW = floor(fs*clickDBtimeMs(startClickNr) / 1000);
    endSampW = floor(fs*clickDBtimeMs(endClickNr) / 1000);
    startSampW = max(1, startSampW);
    endSampW = min(size(musArr44100, 1), endSampW);
    
    fs = 525;
    startSamp = floor(fs*clickDBtimeMs(startClickNr) / 1000);
    endSamp = floor(fs*clickDBtimeMs(endClickNr) / 1000);
    startSamp = max(1, startSamp);
    endSamp = min(size(musArr44100, 1), endSamp);
    
    framePerSec = fs/30;
    sampDiffTime = framePerSec/fs;
    
    [F2, V2] = agent2(0, 0);
    V = [];
    F = [];
    for ind = 1 : 16
        [F, V] = addPoly(F, V, F2, V2);
    end
    V = V + [xDiv/2 0.2 0];
    h = plotPoly(F, V, 'dark', 'edgeOff', 'col', [1 0.5 0.5]);
    
    cl = clock;
    cl = cl(4)*60*60 + cl(5)*60 + cl(6);
    
    
    for gen = 1 : 10
        winnersArr = zeros(2, 1);
        winnersXYarr = zeros(2, 2);
        winnerCounter = 0;
        gjenta = 1;
        bBall = [];
        
        while gjenta == 1 && winnerCounter < 2
            
            %% Run EMU
            sound(musArr44100(startSampW:endSampW), 44100);
            for i = startSamp : framePerSec : endSamp
                % Pause
                del = 0;
                cl_old = cl;
                while del < sampDiffTime
                    cl = clock;
                    cl = cl(4)*60*60 + cl(5)*60 + cl(6);
                    del = cl - cl_old;
                end
                
                V = [];
                F = [];
                indi = 0;
                for x = 1 : 4
                    for y = 1 : 4
                        indi = indi + 1;
                        
                        [F2, V2] = agent2(cntArr525pop(floor(i), 1, indi), cntArr525pop(floor(i), 2, indi));
                        V2 = V2 + [xDiv/2+xDiv*(x-1) 0.2+yDiv*(y-1) 0];
                        [F, V] = addPoly(F, V, F2, V2);
                        
                    end
                end
                
                set(h, 'Vertices', V);
                axis([0 6 0 6 -1 1]);
                view(0,90);
                drawnow;
            end
            
            %% GUI før EVO
            [x, y, b] = ginput2(1);
            
            if b == 3 % lagre move, med høyre mus
                xi = floor(x/xDiv) + 1;
                yi = floor(y/yDiv)+1;
                iWinner = (xi-1)*4 + yi; 
                saveMovToFile(movPop(:, :, iWinner), 4);
                hS = lineBox(xi, yi, xDiv, yDiv, [0.2 0.2 1]);
                pause(1);
                delete(hS);
                
                continue;
            end
            
            
            if b == 103 % g: gjenta uten å legge inn vinner
                gjenta = 1;
            else
                winnerCounter = winnerCounter + 1;
                xi = floor(x/xDiv) + 1;
                yi = floor(y/yDiv)+1;
                iWinner = (xi-1)*4 + yi;
                winnersXYarr(winnerCounter, 1) = xi;
                winnersXYarr(winnerCounter, 2) = yi;
                winnersArr(winnerCounter) = iWinner;
                
                bBall = [bBall lineBox(xi, yi, xDiv, yDiv, [1 0.2 .2])];
                
                fprintf('Winner no: %d , index: %d\n', winnerCounter, iWinner);
            end
            
            if b == 113 % q: slutt alt
                return;
            end
            
        end
        
        %% EVO
        
        winnersArr
        fprintf('Gen: %d\n', gen);
        
        
        
        % EVO
        % husk elite
        movElite1 = movPop(:, :, winnersArr(1));
        movElite2 = movPop(:, :, winnersArr(2));
        
        movPop = copyWinnersToNewPop(movPop, winnersArr); % Copy
        movPop = mutValPop(movPop, 0.12);
        movPop = remValPop(movPop, 0.12);
        movPop = addValPop(movPop, 0.12);
        
        % Cross
        [movC1, movC2] = crossMov( movPop(:,:,winnersArr(1)),  movPop(:,:,winnersArr(2)));
        
        movPop(:,:,1) = movElite1;
        movPop(:,:,2) = movElite2;
        movPop(:,:,3) = movC1;
        movPop(:,:,4) = movC2;
        
        cntArr525pop = makeCntArr525pop(movPop, corArrDB);
        delete(bBall);
        
    end % EVO
    
end

%%

function [hB] = lineBox(xi, yi, xDiv, yDiv, col)
    cX = xi * xDiv -xDiv/2;
    cY = yi * yDiv -xDiv/2;
    hB(1) = line([cX-xDiv/2+0.1 cX+xDiv/2-0.1],[cY-yDiv/2+0.1 cY-yDiv/2+0.1], 'color', col);
    hB(2) = line([cX-xDiv/2+0.1 cX+xDiv/2-0.1],[cY+yDiv/2-0.1 cY+yDiv/2-0.1], 'color', col);
    hB(3) = line([cX-xDiv/2+0.1 cX-xDiv/2+0.1],[cY-yDiv/2+0.1 cY+yDiv/2-0.1], 'color', col);
    hB(4) = line([cX+xDiv/2-0.1 cX+xDiv/2-0.1],[cY-yDiv/2+0.1 cY+yDiv/2-0.1], 'color', col);
end











